#####
###  PHPGateway - A Gateway to PHP
##   Copyright (C) 2003	Wei He (hewei@ied.org.cn)
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
##   along with this program; if not, write to the Free Software
###  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#####


from Globals import DTMLFile, InitializeClass
from os import getcwd
from PHParser import PHParser
import string

addPHPGWForm = DTMLFile('dtml/addPHPGWForm', globals())

def addPHPGateway(self, id, title='', docroot='', REQUEST=None, submit=None):
    """Add a PHParser object with the contents of file. If
    'file' is empty, default document text is used.
    """
    id=str(id)
    title=str(title)
    script = open(INSTANCE_HOME + '/Products/PHParser/dtml/helperphp.dtml').read()

    ob=PHPGateway(script, __name__=id)
    ob.title=title
    ob.isAnObjectManager=1
    ob.docroot=docroot
    d=self._setObject(id, ob)
    if REQUEST is not None:
        try: u=self.DestinationURL()
        except: u=REQUEST['URL1']
        REQUEST.RESPONSE.redirect(u+'/manage_main')
    return ''


class PHPGateway(PHParser):
    """ PHP Gateway """
    meta_type = 'PHPGateway'
    docroot = ''

    _properties = (
        {'id' : 'title', 'type': 'string', 'mode': 'w'},
        {'id' : 'docroot', 'type' : 'string', 'mode' : 'w'},
    )


    # Hooking this method to allow PHParser responses requests
    # with path information following the script. Thus turn PHParser
    # into PHPGateway

    # i.e. If a PHParser object is added to the root folder as phparser_test
    # /phparser_test/bogus.php will be also served by the same script.

    def __bobo_traverse__(self, TraversalRequest, name):

        # make /manage and /manage_xxx urls work
        if string.find(name, 'manage_') == 0 or name == "manage":
            return getattr(self, name)

        self.__realname__ = name
        return self

InitializeClass(PHPGateway)
